// NC_Button_Test2Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "NC_Button_Test2.h"
#include "NC_Button_Test2Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNC_Button_Test2Dlg dialog

CNC_Button_Test2Dlg::CNC_Button_Test2Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNC_Button_Test2Dlg::IDD, pParent)
{

	m_nTrackBar1 = 0;
	m_nTrackBar2 = 0;
	m_nSpin = 0;

	//{{AFX_DATA_INIT(CNC_Button_Test2Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CNC_Button_Test2Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	if(pDX->m_bSaveAndValidate)
	{
		TRACE("New val for slider\n");
		CSliderCtrl* pSlide1 = (CSliderCtrl*) GetDlgItem(IDC_TRACKBAR1);
		m_nTrackBar1 = pSlide1->GetPos();
	}
	//{{AFX_DATA_MAP(CNC_Button_Test2Dlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CNC_Button_Test2Dlg, CDialog)
	//{{AFX_MSG_MAP(CNC_Button_Test2Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_FONT, OnFont)
	ON_WM_VSCROLL()
	ON_BN_CLICKED(IDC_COLOR, OnColor)
	ON_BN_CLICKED(IDC_TEXT_BTN, OnTextBtn)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNC_Button_Test2Dlg message handlers

BOOL CNC_Button_Test2Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_Btn.SubclassDlgItem(IDC_BUTTON1, this);

	m_Btn.BackColor = RGB(110, 255, 113);
	m_Btn.SetTau(90);
	m_Btn.SetGamm(10);
	m_Btn.strTextBtn ="BIG BIG\n TEXT";
	m_Btn.SetFont(14,"Times New Roman");
	
	m_nTrackBar1 = 10;
	m_nTrackBar2 = 90;
	m_nSpin = 20;
	// TODO: Add extra initialization here
	
	CString strText1;
	CSliderCtrl *pSlide1 = (CSliderCtrl*)GetDlgItem(IDC_TRACKBAR1);
	pSlide1->SetRange(-90,90,TRUE);
	pSlide1->SetPos(m_nTrackBar1);
	strText1.Format("%d",pSlide1->GetPos());
	SetDlgItemText(IDC_STATIC_TRACK1,strText1);
	
	pSlide1 = (CSliderCtrl*)GetDlgItem(IDC_TRACKBAR2);
	pSlide1->SetRange(0,90,TRUE);
	pSlide1->SetPos(m_nTrackBar2);
	strText1.Format("%d",pSlide1->GetPos());
	SetDlgItemText(IDC_STATIC_TRACK2,strText1);

	CSpinButtonCtrl* pSpin = (CSpinButtonCtrl*)GetDlgItem(IDC_SPIN1);
	pSpin->SetRange(0,100);
	pSpin->SetPos(m_nSpin);
	strText1.Format("%d",m_nSpin);
	((CSpinButtonCtrl*)pSpin)->GetBuddy()->SetWindowText(strText1);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CNC_Button_Test2Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CNC_Button_Test2Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CNC_Button_Test2Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CNC_Button_Test2Dlg::OnFont() 
{
  CFontDialog dlgFont(m_Btn.GetCurLf());
  //---------- init font dialog ---------------------------------------
  // set dlgFont.m_cf 
  //  realization ...
  dlgFont.m_cf.rgbColors = m_Btn.FontColor;
	
	 //---------- run font dialog ---------------------------------------
 if (dlgFont.DoModal() != IDOK)

    return;
	

  //---------- set font ---------------------------------------
  LOGFONT lf;
  dlgFont.GetCurrentFont(&lf);
  CFont tempFont;
  if(!tempFont.CreateFontIndirect(&lf))
    return;

  m_Btn.SetFont(&lf);
  tempFont.Detach();

  //----------- set color --------------------------------------
  m_Btn.FontColor =  dlgFont.GetColor();
	
}


void CNC_Button_Test2Dlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	CSliderCtrl *pSlide = (CSliderCtrl*)pScrollBar;
	CString strText;
	strText.Format("%d", pSlide->GetPos());
	int nPosMin,nPosMax;
	pSlide->GetRange(nPosMin,nPosMax);
	if(pScrollBar->GetDlgCtrlID() == IDC_TRACKBAR1)
	{
		m_Btn.SetGamm((int)pSlide->GetPos());
		SetDlgItemText(IDC_STATIC_TRACK1,strText);
	}
	if(pScrollBar->GetDlgCtrlID() == IDC_TRACKBAR2)
		{

			m_Btn.SetTau((int)pSlide->GetPos());
			SetDlgItemText(IDC_STATIC_TRACK2,strText);
		}

	if (nSBCode == SB_ENDSCROLL)
	{
		return;
	}
	if(pScrollBar->GetDlgCtrlID() == IDC_SPIN1)
	{
		m_Btn.SetMinIntens(nPos); 
		strText.Format("%d",nPos);
		((CSpinButtonCtrl*)pScrollBar)->GetBuddy()->SetWindowText(strText);
	}
	
	//m_Btn.Invalidate();

	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CNC_Button_Test2Dlg::OnColor() 
{
	CColorDialog dlg(m_Btn.BackColor);
	dlg.m_cc.Flags |= CC_FULLOPEN | CC_RGBINIT;

	if (dlg.DoModal() != IDOK)
		return;

  m_Btn.BackColor = dlg.GetColor();

	//if ( ::IsWindow(m_Btn) )
	//	m_Btn.Invalidate();
	// TODO: Add your control notification handler code here
	
}

void CNC_Button_Test2Dlg::OnTextBtn() 
{
	m_TextDlg.m_strNewText = m_Btn.strTextBtn;
	if (m_TextDlg.DoModal() != IDOK)
		return;
	m_Btn.strTextBtn = m_TextDlg.m_strNewText;
	//m_Btn.Invalidate();
}
