#if !defined(AFX_STYLEBUTTON_H__EB29D253_028D_468C_B875_F5CEDB9C990E__INCLUDED_)
#define AFX_STYLEBUTTON_H__EB29D253_028D_468C_B875_F5CEDB9C990E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// StyleButton.h : header file
#ifdef NC_EXPORT_BUTTON
#define NC_EXPORT_IMPORT __declspec(dllexport)
#else 
#define NC_EXPORT_IMPORT __declspec(dllimport)
#endif



/////////////////////////////////////////////////////////////////////////////
// CStyleButton window

class NC_EXPORT_IMPORT CStyleButton : public CButton
{
// Construction
public:
	CStyleButton();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CStyleButton)
	public:
	
	protected:
	virtual void PreSubclassWindow();
	//}}AFX_VIRTUAL

// Implementation
public:
	void SetFont(LOGFONT* lpLf = NULL);
	void SetText(CString TextBtn = "Text");
	void SetFont(double SizeFont, CString NameFont = "Arial");
	LPLOGFONT GetCurLf();
	void SetMinIntens(int Jmin = 20);
	void SetGamm(double Gamm);
 	void SetTau(double Tau);
	BOOL Init();
	virtual ~CStyleButton();



	__declspec(property(get=GetColorVal,put=PutColorVal)) COLORREF BackColor;
		COLORREF GetColorVal() 
		{ 
			return m_Color; 
		}

		void PutColorVal(COLORREF Color) 
		{ 
			m_Color = Color; 
			Invalidate();
		}
	__declspec(property(get=GetFontColorVal,put=PutFontColorVal)) COLORREF FontColor;
		COLORREF GetFontColorVal() 
		{ 
			return m_FontColor; 
		}

		void PutFontColorVal(COLORREF FontColor) 
		{ 
			m_FontColor = FontColor; 
			Invalidate();
		}

	__declspec(property(get=GetText,put=SetText)) CString strTextBtn;

		CString GetText()
		{
			return m_strTextBtn;		
		}


	protected:
		COLORREF m_Color;
		COLORREF m_FontColor;


	// Generated message map functions
protected:
	// bitmaps for corners and sides LT- left - top, RB - right-bottom
	CBitmap m_BmpL;
  CBitmap m_BmpR;
  CBitmap m_BmpT;
  CBitmap m_BmpB;
  CBitmap m_BmpLT;
  CBitmap m_BmpLB;
  CBitmap m_BmpRT;
  CBitmap m_BmpRB;

  CBitmap m_BmpL2;
  CBitmap m_BmpR2;
  CBitmap m_BmpT2;
  CBitmap m_BmpB2;
  CBitmap m_BmpLT2;
  CBitmap m_BmpLB2;
  CBitmap m_BmpRT2;
  CBitmap m_BmpRB2;

  CRect   m_rcBorder; // border sizes

   
  double m_Tau;
  double m_Gamma;
  CString m_strTextBtn;
	double m_dbSizeFont;
	CString m_strNameFont;
	LOGFONT m_lf;
	int m_Jmin;


	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	//{{AFX_MSG(CStyleButton)
	afx_msg void OnDestroy();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSizing(UINT fwSide, LPRECT pRect);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_STYLEBUTTON_H__EB29D253_028D_468C_B875_F5CEDB9C990E__INCLUDED_)
